



<!DOCTYPE html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      <meta http-equiv="x-ua-compatible" content="ie=edge">
      
        <meta name="description" content="我的技术笔记本~">
      
      
      
        <meta name="author" content="chenyuan">
      
      
        <meta name="lang:clipboard.copy" content="Copy to clipboard">
      
        <meta name="lang:clipboard.copied" content="Copied to clipboard">
      
        <meta name="lang:search.language" content="en">
      
        <meta name="lang:search.result.none" content="No matching documents">
      
        <meta name="lang:search.result.one" content="1 matching document">
      
        <meta name="lang:search.result.other" content="# matching documents">
      
        <meta name="lang:search.tokenizer" content="[\s\-]+">
      
      <link rel="shortcut icon" href="../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-0.17.2, mkdocs-material-2.5.3">
    
    
      
        <title>Flask - notebook</title>
      
    
    
      <link rel="stylesheet" href="../assets/stylesheets/application.aa3de92b.css">
      
    
    
      <script src="../assets/javascripts/modernizr.1aa3b519.js"></script>
    
    
      
        <link rel="stylesheet" href="https://fonts.loli.net/css?family=Roboto:300,400,400i,700|Roboto+Mono">
        <style>body,input{font-family:"Roboto","Helvetica Neue",Helvetica,Arial,sans-serif}code,kbd,pre{font-family:"Roboto Mono","Courier New",Courier,monospace}</style>
      
      <link rel="stylesheet" href="https://fonts.loli.net/icon?family=Material+Icons">
    
    
    
  </head>
  
  
    <body dir="ltr">
  
    <svg class="md-svg">
      <defs>
        
        
          <svg xmlns="http://www.w3.org/2000/svg" width="416" height="448" viewBox="0 0 416 448" id="github"><path fill="currentColor" d="M160 304q0 10-3.125 20.5t-10.75 19T128 352t-18.125-8.5-10.75-19T96 304t3.125-20.5 10.75-19T128 256t18.125 8.5 10.75 19T160 304zm160 0q0 10-3.125 20.5t-10.75 19T288 352t-18.125-8.5-10.75-19T256 304t3.125-20.5 10.75-19T288 256t18.125 8.5 10.75 19T320 304zm40 0q0-30-17.25-51T296 232q-10.25 0-48.75 5.25Q229.5 240 208 240t-39.25-2.75Q130.75 232 120 232q-29.5 0-46.75 21T56 304q0 22 8 38.375t20.25 25.75 30.5 15 35 7.375 37.25 1.75h42q20.5 0 37.25-1.75t35-7.375 30.5-15 20.25-25.75T360 304zm56-44q0 51.75-15.25 82.75-9.5 19.25-26.375 33.25t-35.25 21.5-42.5 11.875-42.875 5.5T212 416q-19.5 0-35.5-.75t-36.875-3.125-38.125-7.5-34.25-12.875T37 371.5t-21.5-28.75Q0 312 0 260q0-59.25 34-99-6.75-20.5-6.75-42.5 0-29 12.75-54.5 27 0 47.5 9.875t47.25 30.875Q171.5 96 212 96q37 0 70 8 26.25-20.5 46.75-30.25T376 64q12.75 25.5 12.75 54.5 0 21.75-6.75 42 34 40 34 99.5z"/></svg>
        
      </defs>
    </svg>
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="drawer">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="search">
    <label class="md-overlay" data-md-component="overlay" for="drawer"></label>
    
      <a href="#flask" tabindex="1" class="md-skip">
        Skip to content
      </a>
    
    
      <header class="md-header" data-md-component="header">
  <nav class="md-header-nav md-grid">
    <div class="md-flex">
      <div class="md-flex__cell md-flex__cell--shrink">
        <a href="../README/" title="notebook" class="md-header-nav__button md-logo">
          
            <i class="md-icon"></i>
          
        </a>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        <label class="md-icon md-icon--menu md-header-nav__button" for="drawer"></label>
      </div>
      <div class="md-flex__cell md-flex__cell--stretch">
        <div class="md-flex__ellipsis md-header-nav__title" data-md-component="title">
          
            
              <span class="md-header-nav__topic">
                notebook
              </span>
              <span class="md-header-nav__topic">
                Flask
              </span>
            
          
        </div>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        
          
            <label class="md-icon md-icon--search md-header-nav__button" for="search"></label>
            
<div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="query" data-md-state="active">
      <label class="md-icon md-search__icon" for="search"></label>
      <button type="reset" class="md-icon md-search__icon" data-md-component="reset" tabindex="-1">
        &#xE5CD;
      </button>
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="result">
          <div class="md-search-result__meta">
            Type to start searching
          </div>
          <ol class="md-search-result__list"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
          
        
      </div>
      
        <div class="md-flex__cell md-flex__cell--shrink">
          <div class="md-header-nav__source">
            


  


  <a href="https://github.com/zjuchenyuan/notebook/" title="Go to repository" class="md-source" data-md-source="github">
    
      <div class="md-source__icon">
        <svg viewBox="0 0 24 24" width="24" height="24">
          <use xlink:href="#github" width="24" height="24"></use>
        </svg>
      </div>
    
    <div class="md-source__repository">
      GitHub
    </div>
  </a>

          </div>
        </div>
      
    </div>
  </nav>
</header>
    
    <div class="md-container">
      
        
      
      
      <main class="md-main">
        <div class="md-main__inner md-grid" data-md-component="container">
          
            
              <div class="md-sidebar md-sidebar--primary" data-md-component="navigation">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    <nav class="md-nav md-nav--primary" data-md-level="0">
  <label class="md-nav__title md-nav__title--site" for="drawer">
    <span class="md-nav__button md-logo">
      
        <i class="md-icon"></i>
      
    </span>
    notebook
  </label>
  
    <div class="md-nav__source">
      


  


  <a href="https://github.com/zjuchenyuan/notebook/" title="Go to repository" class="md-source" data-md-source="github">
    
      <div class="md-source__icon">
        <svg viewBox="0 0 24 24" width="24" height="24">
          <use xlink:href="#github" width="24" height="24"></use>
        </svg>
      </div>
    
    <div class="md-source__repository">
      GitHub
    </div>
  </a>

    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
      


  <li class="md-nav__item">
    <a href="../README/" title="Home" class="md-nav__link">
      Home
    </a>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-2" type="checkbox" id="nav-2">
    
    <label class="md-nav__link" for="nav-2">
      Python
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-2">
        Python
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Python/" title="Python" class="md-nav__link">
      Python
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../gist/" title="Gist Python一些常用代码片段" class="md-nav__link">
      Gist Python一些常用代码片段
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-3" type="checkbox" id="nav-3">
    
    <label class="md-nav__link" for="nav-3">
      Programming Languages
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-3">
        Programming Languages
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../BASH/" title="BASH" class="md-nav__link">
      BASH
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../BAT/" title="BAT批处理" class="md-nav__link">
      BAT批处理
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../C/" title="C语言" class="md-nav__link">
      C语言
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-3-4" type="checkbox" id="nav-3-4">
    
    <label class="md-nav__link" for="nav-3-4">
      Java
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="2">
      <label class="md-nav__title" for="nav-3-4">
        Java
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Java/" title="Java" class="md-nav__link">
      Java
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../S2-045/" title="S2-045" class="md-nav__link">
      S2-045
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../JavaScript/" title="JavaScript" class="md-nav__link">
      JavaScript
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../PHP/" title="PHP" class="md-nav__link">
      PHP
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      

  


  <li class="md-nav__item md-nav__item--active md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-4" type="checkbox" id="nav-4" checked>
    
    <label class="md-nav__link" for="nav-4">
      Web
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-4">
        Web
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../CDN/" title="CDN" class="md-nav__link">
      CDN
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../cURL/" title="cURL" class="md-nav__link">
      cURL
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-4-3" type="checkbox" id="nav-4-3">
    
    <label class="md-nav__link" for="nav-4-3">
      Favorites
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="2">
      <label class="md-nav__title" for="nav-4-3">
        Favorites
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Favorites/" title="Favorites" class="md-nav__link">
      Favorites
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../GithubProjectRecommendation/" title="Github Project Recommendation" class="md-nav__link">
      Github Project Recommendation
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Links/" title="更多链接" class="md-nav__link">
      更多链接
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

        
          
          
          

  


  <li class="md-nav__item md-nav__item--active">
    
    <input class="md-toggle md-nav__toggle" data-md-toggle="toc" type="checkbox" id="toc">
    
      
    
    
      <label class="md-nav__link md-nav__link--active" for="toc">
        Flask
      </label>
    
    <a href="./" title="Flask" class="md-nav__link md-nav__link--active">
      Flask
    </a>
    
      
<nav class="md-nav md-nav--secondary">
  
  
    
  
  
    <label class="md-nav__title" for="toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#app_root" title="应用根目录APP_ROOT" class="md-nav__link">
    应用根目录APP_ROOT
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#approuteintpost" title="app.route里的int和POST" class="md-nav__link">
    app.route里的int和POST
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#render_template" title="render_template引入所有全局变量+局部变量" class="md-nav__link">
    render_template引入所有全局变量+局部变量
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#gisphone" title="判断是否手机访问 g.isphone" class="md-nav__link">
    判断是否手机访问 g.isphone
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#get" title="限制特定get整数参数的取值" class="md-nav__link">
    限制特定get整数参数的取值
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#decorator" title="要求登录的decorator" class="md-nav__link">
    要求登录的decorator
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#import" title="import引入列表" class="md-nav__link">
    import引入列表
  </a>
  
</li>
      
      
      
    </ul>
  
</nav>
    
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../MySQL/" title="MySQL" class="md-nav__link">
      MySQL
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Nginx/" title="Nginx" class="md-nav__link">
      Nginx
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../RabbitMQ/" title="RabbitMQ" class="md-nav__link">
      RabbitMQ
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-5" type="checkbox" id="nav-5">
    
    <label class="md-nav__link" for="nav-5">
      Development
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-5">
        Development
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Developer/" title="Developer" class="md-nav__link">
      Developer
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Docker/" title="Docker" class="md-nav__link">
      Docker
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Git/" title="Git" class="md-nav__link">
      Git
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Jekyll/" title="Jekyll" class="md-nav__link">
      Jekyll
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../WindowsSoftware/" title="WindowsSoftware" class="md-nav__link">
      WindowsSoftware
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-6" type="checkbox" id="nav-6">
    
    <label class="md-nav__link" for="nav-6">
      Linux
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-6">
        Linux
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-backup/" title="Linux-backup" class="md-nav__link">
      Linux-backup
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-setup/" title="Linux-setup" class="md-nav__link">
      Linux-setup
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-SSH/" title="Linux-SSH" class="md-nav__link">
      Linux-SSH
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-cli/" title="Linux-cli" class="md-nav__link">
      Linux-cli
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-VirtualBox/" title="Linux-VirtualBox" class="md-nav__link">
      Linux-VirtualBox
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Ubuntu/" title="Ubuntu" class="md-nav__link">
      Ubuntu
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-7" type="checkbox" id="nav-7">
    
    <label class="md-nav__link" for="nav-7">
      My Projects
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-7">
        My Projects
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../zjugrshelper/" title="ZJU grs helper" class="md-nav__link">
      ZJU grs helper
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
              <div class="md-sidebar md-sidebar--secondary" data-md-component="toc">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    
<nav class="md-nav md-nav--secondary">
  
  
    
  
  
    <label class="md-nav__title" for="toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#app_root" title="应用根目录APP_ROOT" class="md-nav__link">
    应用根目录APP_ROOT
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#approuteintpost" title="app.route里的int和POST" class="md-nav__link">
    app.route里的int和POST
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#render_template" title="render_template引入所有全局变量+局部变量" class="md-nav__link">
    render_template引入所有全局变量+局部变量
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#gisphone" title="判断是否手机访问 g.isphone" class="md-nav__link">
    判断是否手机访问 g.isphone
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#get" title="限制特定get整数参数的取值" class="md-nav__link">
    限制特定get整数参数的取值
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#decorator" title="要求登录的decorator" class="md-nav__link">
    要求登录的decorator
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#import" title="import引入列表" class="md-nav__link">
    import引入列表
  </a>
  
</li>
      
      
      
    </ul>
  
</nav>
                  </div>
                </div>
              </div>
            
          
          <div class="md-content">
            <article class="md-content__inner md-typeset">
              
                
                  <a href="https://github.com/zjuchenyuan/notebook/edit/master/Flask.md" title="Edit this page" class="md-icon md-content__icon">&#xE3C9;</a>
                
                
                <h1 id="flask">Flask 备忘<a class="headerlink" href="#flask" title="Permanent link">&para;</a></h1>
<p>常用的一些操作，自己总结的，便于查阅</p>
<h2 id="app_root">应用根目录APP_ROOT<a class="headerlink" href="#app_root" title="Permanent link">&para;</a></h2>
<div class="codehilite"><pre><span></span>APP_ROOT = os.path.dirname(os.path.abspath(__file__))
</pre></div>


<h2 id="approuteintpost">app.route里的int和POST<a class="headerlink" href="#approuteintpost" title="Permanent link">&para;</a></h2>
<div class="codehilite"><pre><span></span>@app.route(&quot;/list/&lt;int:boardid&gt;&quot;)

@app.route(&quot;/receive_post&quot;, methods=[&quot;POST&quot;])

post_param = int(request.form.get(&quot;post_param&quot;,&quot;0&quot;))
# get参数用request.args
</pre></div>


<h2 id="render_template">render_template引入所有全局变量+局部变量<a class="headerlink" href="#render_template" title="Permanent link">&para;</a></h2>
<div class="codehilite"><pre><span></span>str = str
len = len
int = int

@app.route(&quot;/&quot;)
def index():
    # ... some logic code
    targs = globals()
    targs.update(locals())
    return render_template(&quot;template.html&quot;, **targs)
</pre></div>


<h2 id="gisphone">判断是否手机访问 g.isphone<a class="headerlink" href="#gisphone" title="Permanent link">&para;</a></h2>
<div class="codehilite"><pre><span></span>@app.before_request
def before_request():
    ua = request.user_agent.string.lower()
    for mobileua in &quot;android|fennec|iemobile|iphone|opera mini|opera mobi|mobile&quot;.split(&quot;|&quot;):
        if mobileua in ua:
            g.isphone = True
            break
    else:
        g.isphone = False
</pre></div>


<h2 id="get">限制特定get整数参数的取值<a class="headerlink" href="#get" title="Permanent link">&para;</a></h2>
<div class="codehilite"><pre><span></span>def limit_param(param_name, default_value, minvalue, maxvalue):
    &quot;&quot;&quot;
    example: p = limit_param(&quot;p&quot;, 1, 1, 5)
    &quot;&quot;&quot;
    if maxvalue&lt;minvalue:
        maxvalue = minvalue
    try:
        data = int(request.args.get(param_name, default_value))
    except:
        data = default_value
    if data&lt;minvalue:
        data = minvalue
    elif data &gt; maxvalue:
        data = maxvalue
    return data
</pre></div>


<h2 id="decorator">要求登录的decorator<a class="headerlink" href="#decorator" title="Permanent link">&para;</a></h2>
<p>用法: <code>@require_login()</code> 注意使用时添加到<code>@app.route</code>行的后面</p>
<div class="codehilite"><pre><span></span><span class="kn">import</span> <span class="nn">functools</span>
<span class="kn">from</span> <span class="nn">flask</span> <span class="kn">import</span> <span class="n">session</span><span class="p">,</span> <span class="n">abort</span><span class="p">,</span> <span class="n">redirect</span>
<span class="k">def</span> <span class="nf">require_login</span><span class="p">(</span><span class="n">code</span><span class="o">=</span><span class="mi">200</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="s2">&quot;login first&quot;</span><span class="p">,</span> <span class="n">jumptologin</span><span class="o">=</span><span class="bp">False</span><span class="p">):</span>
    <span class="k">def</span> <span class="nf">real_decorator</span><span class="p">(</span><span class="n">func</span><span class="p">):</span>
        <span class="nd">@functools.wraps</span><span class="p">(</span><span class="n">func</span><span class="p">)</span>
        <span class="k">def</span> <span class="nf">wrapper</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span><span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
            <span class="k">if</span> <span class="s2">&quot;username&quot;</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">session</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">jumptologin</span><span class="p">:</span>
                    <span class="k">return</span> <span class="n">redirect</span><span class="p">(</span><span class="s2">&quot;/signin?error=needlogin&amp;next=&quot;</span><span class="o">+</span><span class="n">signit</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">path</span><span class="p">))</span>
                <span class="k">elif</span> <span class="n">code</span><span class="o">==</span><span class="mi">200</span><span class="p">:</span>
                    <span class="k">return</span> <span class="n">text</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">abort</span><span class="p">(</span><span class="n">code</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="k">return</span> <span class="n">func</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">wrapper</span>
    <span class="k">return</span> <span class="n">real_decorator</span>
</pre></div>


<h2 id="import">import引入列表<a class="headerlink" href="#import" title="Permanent link">&para;</a></h2>
<div class="codehilite"><pre><span></span><span class="kn">from</span> <span class="nn">flask</span> <span class="kn">import</span> <span class="n">Flask</span><span class="p">,</span> <span class="n">render_template</span><span class="p">,</span> <span class="n">Blueprint</span><span class="p">,</span> <span class="n">request</span><span class="p">,</span> <span class="n">redirect</span><span class="p">,</span> <span class="n">Markup</span><span class="p">,</span> <span class="n">g</span><span class="p">,</span> <span class="n">session</span><span class="p">,</span> <span class="n">abort</span><span class="p">,</span> <span class="n">Response</span><span class="p">,</span> <span class="n">make_response</span><span class="p">,</span> <span class="n">send_file</span><span class="p">,</span> <span class="n">jsonify</span>
<span class="kn">from</span> <span class="nn">werkzeug.utils</span> <span class="kn">import</span> <span class="n">secure_filename</span>
<span class="kn">import</span> <span class="nn">time</span>
<span class="kn">import</span> <span class="nn">datetime</span>
<span class="kn">import</span> <span class="nn">random</span>
<span class="kn">import</span> <span class="nn">pickle</span>
<span class="kn">import</span> <span class="nn">requests</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">import</span> <span class="nn">traceback</span>
<span class="kn">import</span> <span class="nn">mimetypes</span>
<span class="kn">import</span> <span class="nn">string</span>
<span class="kn">import</span> <span class="nn">re</span>
<span class="kn">import</span> <span class="nn">hashlib</span>
<span class="kn">import</span> <span class="nn">json</span>
</pre></div>
                
                  
                
              
              
                
              
            </article>
          </div>
        </div>
      </main>
      
        
<footer class="md-footer">
  
    <div class="md-footer-nav">
      <nav class="md-footer-nav__inner md-grid">
        
          <a href="../Links/" title="更多链接" class="md-flex md-footer-nav__link md-footer-nav__link--prev" rel="prev">
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-back md-footer-nav__button"></i>
            </div>
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Previous
                </span>
                更多链接
              </span>
            </div>
          </a>
        
        
          <a href="../MySQL/" title="MySQL" class="md-flex md-footer-nav__link md-footer-nav__link--next" rel="next">
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Next
                </span>
                MySQL
              </span>
            </div>
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-forward md-footer-nav__button"></i>
            </div>
          </a>
        
      </nav>
    </div>
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-footer-copyright">
        
          <div class="md-footer-copyright__highlight">
            <a href=http://www.miitbeian.gov.cn/>浙ICP备15043819号-2</a>&nbsp;&nbsp;<a target=_blank href=http://www.beian.gov.cn/portal/registerSystemInfo?recordcode=33010602007826><img src="/assets/images/beian.png" height=14px>浙公网安备 33010602007826号</p></a>
          </div>
        
        powered by
        <a href="http://www.mkdocs.org">MkDocs</a>
        and
        <a href="https://squidfunk.github.io/mkdocs-material/">
          Material for MkDocs</a>
      </div>
      
        
  <div class="md-footer-social">
    
    <link rel="stylesheet" href="https://cdnjs.loli.net/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    
      <a href="https://github.com/zjuchenyuan" class="md-footer-social__link fa fa-github-alt"></a>
    
      <a href="mailto: py3io.chenyuan@qiushi.ac.cn" class="md-footer-social__link fa fa-envelope"></a>
    
  </div>

      
    </div>
  </div>
</footer>
      
    </div>
    
      <script src="../assets/javascripts/application.f041762f.js"></script>
      
      <script>app.initialize({version:"0.17.2",url:{base:".."}})</script>
      
        <script src="../assets/js/instantclick.min.js"></script>
      
    
    
      
    
  </body>
</html>